// ignore_for_file: public_member_api_docs
@JS()
library firebase_node.interop.js_interop;

import 'package:js/js.dart';
import 'package:js/js_util.dart' as util;

@JS('JSON.stringify')
external String stringify(Object obj);

@JS('Object.keys')
external List<String> objectKeys(Object obj);

@JS('Array.from')
external Object toJSArray(List source);

DateTime dartifyDate(Object jsObject) {
  if (util.hasProperty(jsObject, 'toDateString')) {
    try {
      var date = jsObject as dynamic;
      return DateTime.fromMillisecondsSinceEpoch(date.getTime());
      // ignore: avoid_catching_errors
    } on NoSuchMethodError {
      // so it's not a JsDate!
      return null;
    }
  }
  return null;
}

external dynamic require(String id);

external dynamic get exports;
